/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/kyverno/kyverno/api/policies.kyverno.io/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeValidatingPolicies implements ValidatingPolicyInterface
type FakeValidatingPolicies struct {
	Fake *FakePoliciesV1alpha1
}

var validatingpoliciesResource = v1alpha1.SchemeGroupVersion.WithResource("validatingpolicies")

var validatingpoliciesKind = v1alpha1.SchemeGroupVersion.WithKind("ValidatingPolicy")

// Get takes name of the validatingPolicy, and returns the corresponding validatingPolicy object, and an error if there is any.
func (c *FakeValidatingPolicies) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.ValidatingPolicy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(validatingpoliciesResource, name), &v1alpha1.ValidatingPolicy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ValidatingPolicy), err
}

// List takes label and field selectors, and returns the list of ValidatingPolicies that match those selectors.
func (c *FakeValidatingPolicies) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.ValidatingPolicyList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(validatingpoliciesResource, validatingpoliciesKind, opts), &v1alpha1.ValidatingPolicyList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.ValidatingPolicyList{ListMeta: obj.(*v1alpha1.ValidatingPolicyList).ListMeta}
	for _, item := range obj.(*v1alpha1.ValidatingPolicyList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested validatingPolicies.
func (c *FakeValidatingPolicies) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(validatingpoliciesResource, opts))
}

// Create takes the representation of a validatingPolicy and creates it.  Returns the server's representation of the validatingPolicy, and an error, if there is any.
func (c *FakeValidatingPolicies) Create(ctx context.Context, validatingPolicy *v1alpha1.ValidatingPolicy, opts v1.CreateOptions) (result *v1alpha1.ValidatingPolicy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(validatingpoliciesResource, validatingPolicy), &v1alpha1.ValidatingPolicy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ValidatingPolicy), err
}

// Update takes the representation of a validatingPolicy and updates it. Returns the server's representation of the validatingPolicy, and an error, if there is any.
func (c *FakeValidatingPolicies) Update(ctx context.Context, validatingPolicy *v1alpha1.ValidatingPolicy, opts v1.UpdateOptions) (result *v1alpha1.ValidatingPolicy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(validatingpoliciesResource, validatingPolicy), &v1alpha1.ValidatingPolicy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ValidatingPolicy), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeValidatingPolicies) UpdateStatus(ctx context.Context, validatingPolicy *v1alpha1.ValidatingPolicy, opts v1.UpdateOptions) (*v1alpha1.ValidatingPolicy, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(validatingpoliciesResource, "status", validatingPolicy), &v1alpha1.ValidatingPolicy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ValidatingPolicy), err
}

// Delete takes name of the validatingPolicy and deletes it. Returns an error if one occurs.
func (c *FakeValidatingPolicies) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(validatingpoliciesResource, name, opts), &v1alpha1.ValidatingPolicy{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeValidatingPolicies) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(validatingpoliciesResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.ValidatingPolicyList{})
	return err
}

// Patch applies the patch and returns the patched validatingPolicy.
func (c *FakeValidatingPolicies) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ValidatingPolicy, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(validatingpoliciesResource, name, pt, data, subresources...), &v1alpha1.ValidatingPolicy{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ValidatingPolicy), err
}
